<?php

namespace EventPortal\Domain\Util\Statistics;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Collection;

class Statistics
{
    /**
     * @var Collection
     */
    private $stats;

    /**
     * @var Model
     */
    private $model;

    public function __construct()
    {
        $this->stats = collect();
    }

    public static function make(): self
    {
        return new self;
    }

    public function model(Model $model): self
    {
        $this->model = $model;

        return $this;
    }

    public function add(string $name, callable $callable): self
    {
        $this->stats->put($name, $callable);

        return $this;
    }

    public function render(): Collection
    {
        return $this->stats->map(function ($callable) {
            return $callable($this->model);
        });
    }
}
