<?php

namespace EventPortal\Http\Middleware;

use Closure;
use Illuminate\Http\Request;
use Illuminate\Http\Response;
use Spatie\Permission\Exceptions\UnauthorizedException;

class CheckPermission
{
    /**
     * Handle an incoming request.
     *
     * @return mixed
     */
    public function handle(Request $request, Closure $next, string $permission)
    {
        if (auth()->guest()) {
            throw UnauthorizedException::notLoggedIn();
        }

        abort_unless(auth()->user()->admin->hasPermissionTo($permission), Response::HTTP_UNAUTHORIZED);

        return $next($request);
    }
}
